#include<stdio.h>
main()
{
    int n,q,i,l,r,p;
    scanf("%d%d",&n,&q);
    int a[n],resenje[q];
    for(i=0;i<n;i++)
    {
        scanf("%d",&a[i]);
    }
    for(p=0;p<q;p++)
    {
        scanf("%d%d",&l,&r);
        for(i=l;i<r;i++)
        {
            if(i!=l)
            {
                resenje[p]=resenje[p]&a[i];

            }
            else
            {
                resenje[p]=a[i-1]&a[i];

            }
        }
    }
    for(p=0;p<q;p++)
    {
        printf("%d\n",resenje[p]);
    }
}